﻿using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            #region 열기 마우스 바인딩(CTRL+WHEEL)을 추가한다.

            MouseGesture openMouseGesture = new MouseGesture();

            openMouseGesture.MouseAction = MouseAction.WheelClick;
            openMouseGesture.Modifiers   = ModifierKeys.Control;

            MouseBinding openMouseBinding = new MouseBinding();

            openMouseBinding.Gesture = openMouseGesture;
            openMouseBinding.Command = ApplicationCommands.Open;

            InputBindings.Add(openMouseBinding);

            #endregion
            #region 잘라내기 마우스 바인딩(MIDDLE BUTTON)을 추가한다.

            MouseGesture cutMouseGesture = new MouseGesture(MouseAction.MiddleClick);

            MouseBinding cutMouseBinding = new MouseBinding(ApplicationCommands.Cut, cutMouseGesture);
            
            InputBindings.Add(cutMouseBinding);

            #endregion
            #region 새로 만들기 마우스 바인딩(ALT+MIDDLE BUTTON)을 추가한다.

            MouseGesture newMouseGesture = new MouseGesture();

            newMouseGesture.Modifiers   = ModifierKeys.Alt;
            newMouseGesture.MouseAction = MouseAction.MiddleClick;

            MouseBinding newMouseBinding = new MouseBinding();

            newMouseBinding.Command = ApplicationCommands.New;
            newMouseBinding.Gesture = newMouseGesture;

            InputBindings.Add(newMouseBinding);

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 명령 실행시 처리하기 - command_Executed(sender, e)

        /// <summary>
        /// 명령 실행시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void command_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("명령이 호출되었습니다.");
        }

        #endregion
        #region 명령 실행 가능 여부 구하기 - command_CanExecute(sender, e)

        /// <summary>
        /// 명령 실행 가능 여부 구하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void command_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }

        #endregion
    }
}